//	comApplController.c

#include "comApplController.h"


#include	"general.h"
#include	"file.h"

#include	"comCalc_forContinuumSpace3D.h"
#include	"comCommonTypes.h"	//	ϐ^: comCalcParamType
#include	<string.h>	// strcmp()


//	==================================================
//		O[oϐ
//	==================================================

static double	CfgVersion	= 4.2;

//	p[^
double	AppSysX, AppSysY, AppSysZ;
double	AppSysArea;

int		AppSelectedDeformationType;
int		AppSelectedDistributionType;

double	AppBubbleAspectRatio;
double	AppBubbleInclination;

double	AppSingleSizeBubbleNumber;
double	AppSingleSizeBubbleRadius;

double	AppBubbleVFPresentValue;
double	AppBubbleVFActualValue;
double	AppBubbleVFRangeMax;
double	AppBubbleVFRangeStep;

int		AppTotalRunNumberPerBVF;
int		AppPresentRunNumber;


//===============================
//	vZݒp[^̎
//
comCalcParamType	AppCalcParams;

//	vOԂ̐
int		AppExecuteMode;//	ouzp[^ŗ^邩Ãt@Cǂݍނ.
enum	{
  AppExecute_WithParameters = 0,
  AppExecute_WithMapFiles,
  AppExecute_ContinuumSpaceWithParams = 10
};

//	f[^ۑ
int		AppSaveMode;
char	AppSaveDataFileHeaderPtr[256];// t@Cʕ
char	AppMapFileHeadPtr[256];
char	AppMapFileTailPtr[256];

int		AppSaveAveragesOn;
int		AppSaveEachResultOn;
int		AppSaveEachImageOn;
int		AppSaveEachImageNumberPerVF;// ݒVFɃ}bvۑ: AppSaveEachImageOn = 1 ̂ƂL

int		AppCorrelationFuncOn;	// z̑֊֐тBVF̓vl߂邩.

double	AppResolution;



//	[AppExecute_ContinuumSpaceWithParams]
//	
//		vZ Run#  BVF ȂǂAvZr炻̏
//		t@CpŌvZ邱Ƃo.
//			0: ŏvZ
//			1: pf[^vZ
int		AppContinueMode = 0;
//	
//		vZɁAԐt邱Ƃo.
//			<= 0 ̂ƂA
int		AppCalcLimitTime = 0;
//	
//		vZʂ̉͂ɂāAIvVIȉ͓e̎{tO
int		AppAnalysisExtension = 0;


//////////  MPI
static int		MY_RANK=0, PROC_NUM=1;


//	==================================================
//		O[oϐF܂
//	==================================================
//	==================================================
//		Oɑ΂֐錾
//	==================================================



//	vZ̑Sʂ󂯂.
int		comApp_workWithConfigFile_para
(   const char* progName,	// sĂR}h
    const char* cfgFileName,
    int			my_rank,	//  mpi
    int			proc_num,	//  mpi
    cpresult* cpres,
    int mpiid
    ){
  int	flag = MYSUCCESS;
  double	maxR;
        
	
  MY_RANK = my_rank;
  PROC_NUM = proc_num;
	
  //	̃t@C̃O[oϐ̏
  comApp_applicationDidFinishLaunching();
	
  //	ݒt@Cǂݍ.
  flag = comApp_readCfgFile3D(
    cfgFileName,				//	^(ݒt@C)
    progName,
    AppSaveDataFileHeaderPtr,	//	󂯎(ȉl)
    &AppExecuteMode, 			//	ouzp[^ŗ^邩Ãt@Cǂݍނ.
    AppMapFileHeadPtr,	//	t@C̓ǂݍ݂̏ꍇAʂ̃t@C擪
    AppMapFileTailPtr,	//	t@C̓ǂݍ݂̏ꍇAʂ̃t@C
    &AppSysX,			//	p[^ŗ^ꍇ.
    &AppSysY,
    &AppSysZ,
    &AppCalcParams,	//
    &AppSaveMode,
    &AppSaveAveragesOn,
    &AppSaveEachResultOn,
    &AppSaveEachImageOn,
    &AppSaveEachImageNumberPerVF,
    &AppCorrelationFuncOn,
    &AppResolution,
    &AppContinueMode,
    &AppCalcLimitTime,
    &AppAnalysisExtension
    );
  if( flag == MYERROR ){
    printf("%d :: %s: Error in reading \"%s\"\n\n", MY_RANK, progName, cfgFileName);
    goto end;
  }
	
//	printf("%d :: %s: Reading done.\n", MY_RANK, progName);
	
  //==============================
  //	s̕
  switch( AppExecuteMode ){
  case	AppExecute_ContinuumSpaceWithParams:
    //==============================
    //	^ꂽp[^ɂāA
    //	AԂɂou̕zp[R[V̉͂s.
//			printf("%d :: %s: execute with parameters in a Continuum-Space.\n", MY_RANK, progName);
			
    if((int)AppSysZ == 0){
      //	2D
      //	
      printf("%d :: %s: execute in Continuum-Space of 2D.\n", MY_RANK, progName);
      printf("%d :: XXXXXXXX Not impremented.\n", MY_RANK);
      goto end;
    }
    else{
      //	3D
      //	
      //	
      //	printf("%d :: %s: execute in Continuum-Space of 3D.\n", MY_RANK, progName);
      if( AppCalcParams.distributionType == 0 )
        //	Single-size
        maxR = AppCalcParams.parameters[2];	// Rc
      else	//	Single-size ȊÕTCYz
        maxR = AppCalcParams.parameters[12];// HIGHER = BSD_OPT_2
						
      //////////////////////////////////////
      //  
      if( comCalcCS3D_initWith(
            AppSysX, AppSysY, AppSysZ,
            maxR,
            AppResolution,
            AppCalcParams.lastBVF,
            MY_RANK, PROC_NUM
            ) == MYSUCCESS ){
        //		printf("%d :: %s: comCalcCS3D_initWith() done.\n", MY_RANK, progName);
							
        //////////////////////////////////////
        //	p[^ݒ
        comCalcCS3D_setParameters(&AppCalcParams);
//							printf("%d :: %s: comCalcCS3D_setParameters() done.\n", MY_RANK, progName);
							
        //////////////////////////////////////
        //	ۑt@C̏ݒ
        comCalcCS3D_setFileInfoWith(
          MYYES,	// saveState
          AppSaveDataFileHeaderPtr,	// t@C̋ʕ
          AppSaveMode,
          AppSaveAveragesOn,
          AppSaveEachResultOn,
          AppSaveEachImageOn,
          AppSaveEachImageNumberPerVF
          );
        //	printf("%d :: %s: comCalcCS3D_setFileInfoWith() done.\n", MY_RANK, progName);
							
        //////////////////////////////////////
        //	vZ񐔓t@CpǂA̐ݒ
        comCalcCS3D_setParamsOfContinueMode(
          AppContinueMode,
          AppCalcLimitTime
          );
//							printf("%d :: %s: comCalcCS3D_setParamsOfContinueMode() done.\n", MY_RANK,
        //							   progName);
							
        //////////////////////////////////////
        //	 Options ̐ݒ
        //	opt[0]	֊֐vZ邩Ȃ.
        //		
							
        //  
        //  gꂽ͂sǂ
        comCalcCS3D_setAnalysisExtension( AppAnalysisExtension );
							
        //////////////////////////////////////

        comCalcCS3D_runWithParameters(cpres,mpiid);
        //////////////////////////////////////
        //	n
        comCalcCS3D_dealloc();
        // printf("%d :: %s: deallocation done.\n", MY_RANK, progName);
      }
      else{
        printf("%d :: %s: Error in comCalcCS3D_initWith\n", MY_RANK, progName);
        goto end;
      }
    }
    break;	// AppExecute_ContinuumSpaceWithParams
			
  default:
    //==============================
    printf("%d :: %s: execute with map files.\n", MY_RANK, progName);
    printf("%d :: XXXXXXXX Not impremented.\n", MY_RANK);
    break;
  }//	switch( AppExecuteMode )
	
//	printf("%d :: %s: end.\n\n", MY_RANK, progName);
	
  //	comApp_dealloc();
  end:
  return	flag;
}//	comApp_workWithConfigFile()



//	==================================================
//		AI
//	==================================================


//	AvP[ṼfQ[gƂẴNX
//	CX^X\[Xœo^Ă̂ŁA
//	AvNɂ̃\bhĂ΂.
void	comApp_applicationDidFinishLaunching()
{
  AppSysX = 0.0;
  AppSysY = 0.0;
  AppSysZ = 0.0;
	
  AppSelectedDeformationType = DEFORMTYPE_BUBBLE;
  AppSelectedDistributionType = BSDTYPE_SINGLEBUBBLE;
	
  AppTotalRunNumberPerBVF = 0;
  AppPresentRunNumber = 0;
	
  //	AppTotalClusterNumber = 0;
  //	AppPercolationNumberX = 0;
  //	AppPercolationNumberY = 0;
  //	AppPercolationNumberZ = 0;
	
  //	AppPClusterNumberX	= 0;
  //	AppPClusterNumberY	= 0;
  //	AppPClusterNumberZ	= 0;
	
}//	comApp_applicationDidFinishLaunching





//	==================================================
//		ݒt@Cǂݍ
//	==================================================

#define	DEFcomApp_maxline	1000

int		comApp_readCfgFile3D(	//	܂ǂݍ߂ǂԂ.
  const char* fileName,	//	^(ݒt@C)
  const char* progName,
  char*	fileHeader,	//	t@C̋ʕ
  int*	executeMode, //	ouzp[^ŗ^邩Ãt@Cǂݍނ.
  char*	mapFileHead,	//	t@C̓ǂݍ݂̏ꍇAʂ̃t@C擪
  char*	mapFileTail,	//	t@C̓ǂݍ݂̏ꍇAʂ̃t@C
  double*	sysX,	//	p[^ŗ^ꍇ.
  double*	sysY,
  double*	sysZ,
  comCalcParamType*	calcParams,	//
  int*	saveMode,	//	f[^ǂۑ邩
  int*	saveAve,
  int*	saveEachRes,
  int*	saveEachImg,
  int*	saveFileNumOfEachImgPerVF, // ݒVFɁA}bvۑ: saveEachImg = 1 ̂ƂL
  int*	correlationFunc,	// z̑֊֐тBVF̓vl߂邩.
  double*	resolution,	//	AԂ̃p[R[V̎Aݒ肳
  int*	continueMode,
  int*	limitTime,
  int*	analysis_ext
  )
{
  int		flag = MYSUCCESS;
  FILE*	cfgFP;
  char	line[DEFcomApp_maxline];
  char	str[256], tail[256];
  int		iValue;
  double	dValue;
  double	version;
	
  if( (cfgFP = fopen(fileName,"r")) != NULL ){
    //	1s: "@ Percolation configuration file"
    fgets(line, DEFcomApp_maxline, cfgFP);
    if( strcmp(line, "@ Percolation configuration file\n") != 0 ){
      //	t@C͐Ȃ
//      printf("%d :: 0: %s", MY_RANK, line);
//      printf("%d :: %s: \"%s\" is wrong as a configuration file.\n", MY_RANK,
      //           progName, fileName);
      flag = MYERROR;
      goto end;
    }
		
    //
//    printf("%d :: ---> Parameter-Check\n", MY_RANK);
		
    //	VERSION
    //	
    if( (flag = seek_Double_from_Stream(cfgFP, '#',
                                        "BMVERSION",	&dValue)) == MYSUCCESS ){
      version = dValue;
//      printf("%d :: \tConfig file Version\t%lf\n", MY_RANK, version);
      if(version >= CfgVersion){
        //	No problem
      }
      else{
              printf("%d :: \tIt is less than the progrqam version, [%lf].\n", MY_RANK, CfgVersion);
      }
    }
    else{	goto end;}
		
		
    //	RUNNAME
    //		Common part of name for run series
    flag = seek_Str_from_Stream(cfgFP,
                                '#',	// XLbvs̃Rg
                                "RUNNAMETAIL",	//	̕ɑ
                                str
                                );
    if( flag == MYSUCCESS ){
      if( get_Str_from_quoted_str(str, tail) == MYSUCCESS ){
        // _uNH[e[V͂
//        printf("%d :: \tFileTail\t%s\n", MY_RANK, tail);
      }
      else{	goto end;}
    }
    else{		goto end;}
		
    //	executeMode:
    //		EXECUTE_MODE
    {
      *executeMode = 10;  //  "Calc with Parameters for Bubbles in a Continuum Space"
//      printf("%d :: \tExecuteMode\t%d\n", MY_RANK, *executeMode);
    }
		
    //============================================
    //	SAVE_MODE
    /*
      #		0	"average data without statistical cluster size"
      #		1	"average data with statistical cluster size"
    */
    if( (flag = seek_Int_from_Stream(cfgFP, '#',
                                     "SAVE_MODE",	&iValue)) == MYSUCCESS )
      *saveMode	= iValue;
    else	goto end;
    //
    //	SAVE_AVERAGE
    if( (flag = seek_Int_from_Stream(cfgFP, '#',
                                     "SAVE_AVERAGE",	&iValue)) == MYSUCCESS )
      *saveAve	= iValue;
    else	goto end;
    //
    //	SAVE_EACHRESULT
    if( (flag = seek_Int_from_Stream(cfgFP, '#',
                                     "SAVE_EACHRESULT",	&iValue)) == MYSUCCESS )
      *saveEachRes	= iValue;
    else	goto end;
		
    //============================================
    //	RANDOM_SEED
    if( (flag = seek_Int_from_Stream(cfgFP, '#',
                                     "RANDOM_SEED",	&iValue)) == MYSUCCESS )
      calcParams->randomSeed	= iValue;
    else	goto end;
		
		
    //	*executeMode Ŏc̓ǂݍݏ𕪊
    switch( *executeMode ){
    case	AppExecute_ContinuumSpaceWithParams:
      //============================================
      //	vZp[^ǂݍ
      //============================================
      //	Lx
      if( (flag = seek_Double_from_Stream(cfgFP, '#',
                                          "Lx",	&dValue)) == MYSUCCESS ){
        *sysX = dValue;
//        printf("%d :: \tSysX\t%lf\n", MY_RANK, *sysX);
      }
      else{	goto end;}
				
      //============================================
      //	Ly
      if( (flag = seek_Double_from_Stream(cfgFP, '#',
                                          "Ly",	&dValue)) == MYSUCCESS ){
        *sysY = dValue;
//        printf("%d :: \tSysY\t%lf\n", MY_RANK, *sysY);
      }
      else{	goto end;}
				
      //============================================
      //	Lz
      if( (flag = seek_Double_from_Stream(cfgFP, '#',
                                          "Lz",	&dValue)) == MYSUCCESS ){
        *sysZ = dValue;
//        printf("%d :: \tSysZ\t%lf\n", MY_RANK, *sysZ);
      }
      else{	goto end;}
				
      //============================================
      //	FileHead
      sprintf(fileHeader, "%d_%d_%d_%s",
              (int)(*sysX), (int)(*sysY), (int)(*sysZ),
              tail);
//      printf("%d :: \tFileHead\t%s\n", MY_RANK, fileHeader);
				
//      printf("%d :: \t...\n", MY_RANK);
				
      //============================================
      //	bubblePositionMode
      //	ouʒuvZp^^Cv
      //		0: double
      calcParams->bubblePositionMode	= 0;
				
      //============================================
      //	POSITION_TYPE
      //		0 "bubble positions at random on a rectangular space",
      calcParams->bubblePositionType	= 0;
				
      //============================================
      //	DEFORM_TYPE:	ou̕ό`̎d
      //		0 "Deform of Bubbles"
      calcParams->deformationType	= 0;
      //
      //	Bubble-aspect-ratio
      calcParams->parameters[3]	= 1.0;
      //  
      //	Bubble-inclination-angle-from-x-axis
      calcParams->parameters[4]	= 0.0;
				
      //============================================
      //	DISTRIB_TYPE:	ouTCYẑ (BSD)
      //		0 "Single-size"
      calcParams->distributionType	= 0;
      //
      //	BSD_OPT_0:	W΍ or xLz̎w
      calcParams->parameters[10]	= 0;
      //
      //	BSD_OPT_1:	ouTCỶ
      calcParams->parameters[11]	= 0;
      //
      //	BSD_OPT_2:	ouTCY̏
      calcParams->parameters[12]	= 0;
				
      //============================================
      //	Bn: Bubble Number (w肵ĂӖ)
      calcParams->parameters[1]	= 0;
				
      //============================================
      //	Rc: Bubble Radius before deformation
      //		when Rc = 0, dot-mode will be executed.
      if( (flag = seek_Double_from_Stream(cfgFP, '#',
                                          "Rc",	&dValue)) == MYSUCCESS ){
        calcParams->parameters[2]	= dValue;
//        printf("%d :: \tRc (Bubble Radius)\t%lf\n", MY_RANK, dValue);
      }   else{	goto end;}
				
      //============================================
      //  CALC_RANGE
      //
      //	initBVF
//      printf("%d :: \tCalculation Range of BVF\n", MY_RANK);
      if( (flag = seek_Double_from_Stream(cfgFP, '#',
                                          "initBVF",	&dValue)) == MYSUCCESS ){
        calcParams->initBVF	= dValue;
//        printf("%d :: \tinit\t%lf\n", MY_RANK, dValue);
      }	else{	goto end;}
      //
      //	lastBVF
      if( (flag = seek_Double_from_Stream(cfgFP, '#',
                                          "lastBVF",	&dValue)) == MYSUCCESS ){
        calcParams->lastBVF	= dValue;
//        printf("%d :: \tlast\t%lf\n", MY_RANK, dValue);
      }   else{	goto end;}
      //
      //	stepBVF
      if( (flag = seek_Double_from_Stream(cfgFP, '#',
                                          "stepBVF",	&dValue)) == MYSUCCESS ){
        calcParams->stepBVF	= dValue;
//        printf("%d :: \tstep\t%lf\n", MY_RANK, dValue);
      }   else{	goto end;}
				
      //============================================
      //	totalRunNumberPerBVF
      if( (flag = seek_Int_from_Stream(cfgFP, '#',
                                       "totalRunNumberPerBVF",	&iValue)) == MYSUCCESS ){
        calcParams->totalRunNumberPerBVF	= iValue;
//        printf("%d :: \ttotalRunNumberPerBVF\t%d\n", MY_RANK, iValue);
      }   else{	goto end;}
				
      //============================================
      //  SAVE_MODE_OPTIONS
      //		SAVE_EACHMAP
      if( (flag = seek_Int_from_Stream(cfgFP, '#',
                                       "SAVE_EACHMAP",
                                       &iValue)) == MYSUCCESS ){
        *saveEachImg	= iValue;
//					printf("%d :: \tSAVE_EACHMAP\t%s\n", MY_RANK, (*saveEachImg>0)? "ON":"OFF");
      }
      else{	goto end;}
      //
      //	SAVE_MAPNUM_PER_BVF
      if( (flag = seek_Int_from_Stream(cfgFP, '#',
                                       "SAVE_MAPNUM_PER_BVF",	&iValue)) == MYSUCCESS ){
        *saveFileNumOfEachImgPerVF	= iValue;
        //					printf("%d :: \tSAVE_MAPNUM_PER_BVF\t%d\n", MY_RANK, *saveFileNumOfEachImgPerVF);
      }
      else{	*saveFileNumOfEachImgPerVF = calcParams->totalRunNumberPerBVF;}
					
      //============================================
      //	CORRELATION_FUNC
      *correlationFunc = 0;
				
      //============================================
      //	CONTINUE_MODE
      *continueMode	= 0;
//				printf("%d :: \tCONTINUE_MODE\t%s\n", MY_RANK, (*continueMode>0)? "ON":"OFF");
				
      //============================================
      //	CALC_LIMIT_TIME
      *limitTime	= 0;
//				printf("%d :: \tCALC_LIMIT_TIME\t%d\n", MY_RANK, *limitTime);
					
      //============================================
      //	ANALYSIS_EXTENSION
      *analysis_ext	= 0;
				
      break;
				
    default:
      break;
    }//	switch( *executeMode )
		
		
    //============================================
    //	ǉ: vZp[^ǂݍ
    //============================================
    if( *executeMode == AppExecute_ContinuumSpaceWithParams ){
      //============================================
      //	Resolution
      if( (flag = seek_Double_from_Stream(cfgFP, '#',
                                          "Resolution",	&dValue)) == MYSUCCESS ){
        *resolution	= dValue;
//        printf("%d :: \tResolution\t%lf\n", MY_RANK, *resolution);
      }
      else{	goto end;}
			
    }
		
    fclose(cfgFP);
  }//	if(fopen() != NULL)
  else{
    flag = MYERROR;
  }
	
  end:
  return	flag;
}//	comApp_readCfgFile3D




