/*
 *  distributions.c
 *  PercolationCheck
 *
 *  Created by V T on Fri Aug 01 2003.
 *  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
 *
 */
/*
	^ꂽ2z񒆂ɁAw肳ꂽp[^őȉ~𕪕z.
*/

#include <stdio.h>
#include <math.h>
#include "distributions.h"
#include "general.h"
#include "my_rand.h"
#include "rand_mt19937ar.h" //  mt
#include "sort.h"

static int	ciDistributedBubbleNumber = 0;


//  my_double_rand() AMT Œu邱Ƃł.
#ifdef  RAND_MT
#define FUNC_RAND_DOUBLE()	genrand_real2()
#else
#define FUNC_RAND_DOUBLE()	my_double_rand()
#endif

//  my_int_rand() ͓ʂ̂܂.


//	ԓIɃ_Ƀou𕪕zB
//	
//	oȗ̐ς̊֌WF
//		theMaxX theMaxY theBVF == Pi R^2 n(R)
//	
//	theBNum > 0 ̂Ƃ̓ouwƂ݂Ȃ
//		n(R) = theBNum ƂAR vZ狁߂B
//	theBNum = 0 ̂Ƃ̓ouawƂ݂ȂA
//		R = theR Ƃ n vZ狁߂B
//
//	ۂɕzꂽTCgԂ.
//
/*	New version
*	ȉ~ہA̒Sn͂ݏoƂȂ.
*	->	new ł n͂ݏoĂAȉ~̒[nɂ邱Ƃ
*		悤ɕύX
*/
int	distMap_WithSingleSizeBubble(
		int	*theMap[], // zĕԂ}bv
		int		theMaxX,
		int		theMaxY,
		double	theBVF,	//	ou̕ϑ̐ϊ
		int	theBNum,//	oǔ
		double	theR,	//	ou̔a
		double	theAspect,	//	oũAXyNg
		double	theInclination	//	̃oǔX[degree]
)
{
	int	totalSiteNum;
	int	actualSiteNum;	//	ouŐ߂TCg
	int	occupiedSite;
	int			dx,dy, tryNum, diffSiteNum/*, intRand*/;
	double		tmpBVF;
	double		cx,cy;	//	eou̒SW
	double		x,y;	//	W
	double	xr,yr,xx,yy;//	]̍WAȉ~̌ʂW
	double	angle;	//	radian
	double	r,r2,major,minor;
	double	dist2;
	int		bnum;
	double		winW, winH, winX0,winY0,winX1,winY1;
	double		winWhalf, winHhalf;
	double		sqrtOfAspect, invsqrtOfAspect, cosAngle, sinAngle;
	//	ouuƂŃTCgɕω
	//	ׂEBhE
	//double		dRand;
	int		dotMode = 0;
	
	if( theBNum == 0 ){
		//ouaw
		r = theR;
		r2 = r*r;
		if( r > 0.0 ){
			bnum = (int) (theBVF * theMaxX * theMaxY / (THE_PI * r2));
		}
		else{
			dotMode = 1;
		}
	}
	else{//	ouw
		bnum = theBNum;
		r2 = (theBVF * theMaxX * theMaxY) / (THE_PI * bnum);
		r = sqrt(r2);
	}
	
	totalSiteNum = (int) (theBVF * theMaxX * theMaxY);
	actualSiteNum = 0;
	
	//	zoȕ
	ciDistributedBubbleNumber = 0;
	
	//==========================
	//	dot ̏ꍇ
	//==========================
	if( dotMode ){
		//	
		if( theBVF < 0.5 ){
			while( actualSiteNum < totalSiteNum ){
				//intRand = my_int_rand(theMaxX * theMaxY -1);
				//dx	= intRand % theMaxX;	//  0 ~ theMaxX-1
				//dy	= intRand / theMaxX;	//  0 ~ theMaxY-1
				dx  = my_int_rand(theMaxX -1);
				dy  = my_int_rand(theMaxY -1);
				
				if( theMap[dy][dx] == DATATYPE_VACANT ){
					theMap[dy][dx] = DATATYPE_OCCUPIED;
					actualSiteNum++;
				}
			}//	while
		}//	if( theBVF < 0.5 )
		else{
			//	܂n̒[瑍Ŏ߂̊mŃTCg𖄂߂Ă.
			tryNum = 0;
			for(dy=0; dy<theMaxY; dy++){
				for(dx=0; dx<theMaxX; dx++){
					if( FUNC_RAND_DOUBLE() < (theBVF*0.95) ){
						theMap[dy][dx] = DATATYPE_OCCUPIED;
						actualSiteNum += 1;
					}
					if( actualSiteNum >= totalSiteNum ){
						//	𖞑A֐𔲂.
						//printf("[%d] actualSiteNum = %d / totalSiteNum = %d\n",
						//		tryNum, actualSiteNum, totalSiteNum);
						ciDistributedBubbleNumber = actualSiteNum;
						goto end;
					}
				}//	x
			}//	y
			
			//printf("[%d] actualSiteNum = %d / totalSiteNum = %d\n",
			//		tryNum, actualSiteNum, totalSiteNum);
			
			//	܂ȂAȂ̊mŃTCg𖄂߂Ă.
			tryNum++;
			while( actualSiteNum < totalSiteNum ){
				//	Ȃ
				diffSiteNum = totalSiteNum - actualSiteNum;
				//	c̖܂ĂȂTCgɑ΂Ă̊
				tmpBVF = (double)diffSiteNum / ((double)(theMaxX * theMaxY - actualSiteNum));
				//printf("[%d] tmpBVF = %lf\n", tryNum, tmpBVF);
				//	܂܂ĂȂTCgAmIɖ߂.
				for(dy=0; dy<theMaxY; dy++){
					for(dx=0; dx<theMaxX; dx++){
						if( theMap[dy][dx] == DATATYPE_VACANT ){
							if( FUNC_RAND_DOUBLE() < (tmpBVF) ){
								theMap[dy][dx] = DATATYPE_OCCUPIED;
								actualSiteNum += 1;
							}
							if( actualSiteNum >= totalSiteNum ){
								//	𖞑A֐𔲂.
								//printf("[%d] actualSiteNum = %d / totalSiteNum = %d\n",
								//		tryNum, actualSiteNum, totalSiteNum);
								ciDistributedBubbleNumber = actualSiteNum;
								goto end;
							}
						}//	if(theMap[dy][dx] == DATATYPE_VACANT)
					}//	x
				}//	y
				//printf("[%d] actualSiteNum = %d / totalSiteNum = %d\n",
				//		tryNum, actualSiteNum, totalSiteNum);
				tryNum++;
			}//	while
			ciDistributedBubbleNumber = actualSiteNum;
			goto end;
		}//	theBVF >= 0.5
	}//	if( dotMode )
	
	//==========================
	//	́Aȉ~̏ꍇ
	//==========================
	
	//	ȉ~̌`: 
	//	theAspect := major/minor
	//	Pi major minor == Pi r^2
	//		->	theAspect minor^2 = r^2
	//		->	minor = sqrt(r^2/theAspect)
	//	major = r * sqrt(theAspect)
	//	minor = r / sqrt(theAspect)
	sqrtOfAspect = sqrt(theAspect);
	invsqrtOfAspect	= 1.0/sqrtOfAspect;
	major = r * sqrtOfAspect;
	minor = r * invsqrtOfAspect;
	
	//	]pradianɕϊ
	angle = THE_PI * theInclination / 180.0;
	cosAngle	= cos(-angle);
	sinAngle	= sin(-angle);
	//	ڔ͈͂̃TCY
	winWhalf	= major+2.0;
	winHhalf	= major+2.0;
	winW = winWhalf*2.0;
	winH = winHhalf*2.0;
	
	while( actualSiteNum < totalSiteNum ){
		
		//	Vȃou̍W
		//	0ȏ theMaxX * theMaxY -1 ȉ̗
		//intRand = my_int_rand(theMaxX * theMaxY -1);
		
		//	oũZ^[W
		//	SW͌n甼a͂ݏo.
		cx = FUNC_RAND_DOUBLE() * (theMaxX + winW);// 0 <= cx < theMaxX +winW
		cy = FUNC_RAND_DOUBLE() * (theMaxY + winH);// 0 <= cy < theMaxY +winH
		cx -= winWhalf;	//	-winW/2 <= cx < theMaxX +winW/2
		cy -= winHhalf;	//	-winH/2 <= cy < theMaxY +winH/2
		
		//	ڔ͈͂̐ݒ: 
		//	͈͕͂K^[Qbg̈ (0<=x<theMaxX, 0<=y<theMaxY) 
		//	܂悤.
		winX0 = cx - winWhalf;
		winX0 = (winX0 < 0.0)? 0:winX0;
		
		winX1 = cx + winWhalf;
		winX1 = ((double)theMaxX <= winX1)? (double)(theMaxX-1):winX1;
		
		winY0 = cy - winHhalf;
		winY0 = (winY0 < 0.0)? 0:winY0;
		
		winY1 = cy + winHhalf;
		winY1 = ((double)theMaxY <= winY1)? (double)(theMaxY-1):winY1;
		
		occupiedSite = 0;
		for(y=winY0; y<winY1+1.0; y+=0.5){
			for(x=winX0; x<winX1+1.0; x+=0.5){
				//	]̌ʁFɖ߂
				xr = cx+ (x-cx)*cosAngle - (y-cy)*sinAngle;
				yr = cy+ (x-cx)*sinAngle + (y-cy)*cosAngle;
				
				//	ȉ~̌ʁF~ɖ߂
				xx = cx + (xr -cx) * invsqrtOfAspect;
				yy = cy + (yr -cy) * sqrtOfAspect;
				
				//	xx, yy Aar̉~ɂlZbg
				dist2 = (xx-cx)*(xx-cx)+(yy-cy)*(yy-cy);
				if( dist2 <= r2 ){
					if( theMap[(int)y][(int)x] == DATATYPE_VACANT ){
						theMap[(int)y][(int)x] = DATATYPE_OCCUPIED;
						occupiedSite++;
					}
				}
			}//	for(x)
		}//	for(y)
		
		//	oũJEg.
		ciDistributedBubbleNumber += (occupiedSite > 0)? 1:0;
		
		//	TCg̃JEg.
		actualSiteNum += occupiedSite;
	}//	while()
	
  end:
	return	actualSiteNum;
}//	distMap_WithSingleSizeBubble()





int		distMap_WithSingleSizeBubble_int(
		int	*theMap[],
		int		theMaxX,
		int		theMaxY,
		double	theBVF,	//	ou̕ϑ̐ϊ
		int	theBNum,//	oǔ
		double	theR,	//	ou̔a
		double	theAspect,	//	oũAXyNg
		double	theInclination	//	̃oǔX[degree]
)
{
	int	totalSiteNum;
	int	actualSiteNum;	//	ouŐ߂TCg
	int	occupiedSite;
	int		cx,cy;	//	eou̒SW
	int	tryNum, diffSiteNum;
	double	tmpBVF;
	int		x,y;	//	W
	double	xr,yr,xx,yy;//	]̍WAȉ~̌ʂW
	double	angle;	//	radian
	double	r,r2,major,minor;
	double	dist2;
	int	bnum;
	int		winW, winH, winX0,winY0,winX1,winY1;
	int		winWhalf, winHhalf;
	double		sqrtOfAspect, invsqrtOfAspect, cosAngle, sinAngle;
	//	ouuƂŃTCgɕω
	//	ׂEBhE
	int		intRand;
	int		dotMode = 0;
	
	if( theBNum == 0 ){
		//ouaw
		r = theR;
		r2 = r*r;
		if( r > 0.0 ){
			bnum = (int) (theBVF * theMaxX * theMaxY / (THE_PI * r2));
		}
		else{
			dotMode = 1;
		}
	}
	else{//	ouw
		bnum = theBNum;
		r2 = (theBVF * theMaxX * theMaxY) / (THE_PI * bnum);
		r = sqrt(r2);
	}
	
	totalSiteNum = (int) (theBVF * theMaxX * theMaxY);
	actualSiteNum = 0;
	
	//	zoȕ
	ciDistributedBubbleNumber = 0;
	
	//==========================
	//	dot ̏ꍇ
	//==========================
	if( dotMode ){
		//	
		if( theBVF < 0.5 ){
			while( actualSiteNum < totalSiteNum ){
				//intRand = my_int_rand(theMaxX * theMaxY -1);
				//cx	= intRand % theMaxX;
				//cy	= intRand / theMaxX;
				cx	= my_int_rand(theMaxX-1);
				cy	= my_int_rand(theMaxY-1);
				
				if( theMap[cy][cx] == DATATYPE_VACANT ){
					theMap[cy][cx] = DATATYPE_OCCUPIED;
					actualSiteNum++;
				}
			}//	while
		}//	if( theBVF < 0.5 )
		else{
			//	܂n̒[瑍Ŏ߂̊mŃTCg𖄂߂Ă.
			tryNum = 0;
			for(cy=0; cy<theMaxY; cy++){
				for(cx=0; cx<theMaxX; cx++){
					if( FUNC_RAND_DOUBLE() < (theBVF*0.95) ){
						theMap[cy][cx] = DATATYPE_OCCUPIED;
						actualSiteNum += 1;
					}
					if( actualSiteNum >= totalSiteNum ){
						//	𖞑A֐𔲂.
						//printf("[%d] actualSiteNum = %d / totalSiteNum = %d\n",
						//		tryNum, actualSiteNum, totalSiteNum);
						ciDistributedBubbleNumber = actualSiteNum;
						goto end;
					}
				}//	x
			}//	y
			
			//printf("[%d] actualSiteNum = %d / totalSiteNum = %d\n",
			//		tryNum, actualSiteNum, totalSiteNum);
			
			//	܂ȂAȂ̊mŃTCg𖄂߂Ă.
			tryNum++;
			while( actualSiteNum < totalSiteNum ){
				//	Ȃ
				diffSiteNum = totalSiteNum - actualSiteNum;
				//	c̖܂ĂȂTCgɑ΂Ă̊
				tmpBVF = (double)diffSiteNum / ((double)theMaxX * theMaxY - actualSiteNum);
				//printf("[%d] tmpBVF = %lf\n", tryNum, tmpBVF);
				//	܂܂ĂȂTCgAmIɖ߂.
				for(cy=0; cy<theMaxY; cy++){
					for(cx=0; cx<theMaxX; cx++){
						if( theMap[cy][cx] == DATATYPE_VACANT ){
							if( FUNC_RAND_DOUBLE() < (tmpBVF) ){
								theMap[cy][cx] = DATATYPE_OCCUPIED;
								actualSiteNum += 1;
							}
							if( actualSiteNum >= totalSiteNum ){
								//	𖞑A֐𔲂.
								//printf("[%d] actualSiteNum = %d / totalSiteNum = %d\n",
								//		tryNum, actualSiteNum, totalSiteNum);
								ciDistributedBubbleNumber = actualSiteNum;
								goto end;
							}
						}//	if(theMap[cy][cx] == DATATYPE_VACANT)
					}//	x
				}//	y
				//printf("[%d] actualSiteNum = %d / totalSiteNum = %d\n",
				//		tryNum, actualSiteNum, totalSiteNum);
				tryNum++;
			}//	while
			ciDistributedBubbleNumber = actualSiteNum;
			goto end;
		}//	theBVF >= 0.5
	}//	if( dotMode )
	
	//==========================
	//	́Aȉ~̏ꍇ
	//==========================
	
	//	ȉ~̌`: 
	//	theAspect := major/minor
	//	Pi major minor == Pi r^2
	//		->	theAspect minor^2 = r^2
	//		->	minor = sqrt(r^2/theAspect)
	//	major = r * sqrt(theAspect)
	//	minor = r / sqrt(theAspect)
	sqrtOfAspect = sqrt(theAspect);
	invsqrtOfAspect	= 1.0/sqrtOfAspect;
	major = r * sqrtOfAspect;
	minor = r * invsqrtOfAspect;
	
	//	]pradianɕϊ
	angle = THE_PI * theInclination / 180.0;
	cosAngle	= cos(-angle);
	sinAngle	= sin(-angle);
	//	ڔ͈͂̃TCY
	winWhalf	= major+2;
	winHhalf	= major+2;
	winW = winWhalf*2;
	winH = winHhalf*2;
	
	while( actualSiteNum < totalSiteNum ){
		
		//	Vȃou̍W
		//	0ȏ theMaxX * theMaxY -1 ȉ̗
		//intRand = my_int_rand(theMaxX * theMaxY -1);
		intRand = my_int_rand((theMaxX+winW) * (theMaxY+winH) -1);
		
		//	oũZ^[W
		cx = intRand % (theMaxX+winW);
		cy = intRand / (theMaxX+winW);
		cx -= winWhalf;	//	-winW/2 <= cx < theMaxX +winW/2
		cx -= winHhalf;	//	-winH/2 <= cy < theMaxY +winH/2
		
		//	ڔ͈͂̐ݒ
		winX0 = cx - winWhalf; winX0 = (winX0 < 0)? 0:winX0;
		winX1 = cx + winWhalf; winX1 = (theMaxX <= winX1)? theMaxX-1:winX1;
		winY0 = cy - winHhalf; winY0 = (winY0 < 0)? 0:winY0;
		winY1 = cy + winHhalf; winY1 = (theMaxY <= winY1)? theMaxY-1:winY1;
		
		occupiedSite = 0;
		for(y=winY0; y<=winY1; y++){
			for(x=winX0; x<=winX1; x++){
				//	]̌ʁFɖ߂
				xr = cx+ (double)(x-cx)*cosAngle - (double)(y-cy)*sinAngle;
				yr = cy+ (double)(x-cx)*sinAngle + (double)(y-cy)*cosAngle;
				
				//	ȉ~̌ʁF~ɖ߂
				xx = cx + (xr -(double)cx) * invsqrtOfAspect;
				yy = cy + (yr -(double)cy) * sqrtOfAspect;
				
				//	xx, yy Aar̉~ɂlZbg
				dist2 = (xx-(double)cx)*(xx-(double)cx)
						+(yy-(double)cy)*(yy-(double)cy);
				if( dist2 <= r2 ){
					if( theMap[y][x] == DATATYPE_VACANT ){
						theMap[y][x] = DATATYPE_OCCUPIED;
						occupiedSite++;
					}
				}
			}//	for(x)
		}//	for(y)
		
		//	oũJEg.
		ciDistributedBubbleNumber += (occupiedSite > 0)? 1:0;
		
		//	TCg̃JEg.
		actualSiteNum += occupiedSite;
	}//	while()
	
  end:
	return	actualSiteNum;
}//	distMap_WithSingleSizeBubble_int()






//	L*L Ԃł̃_zu
//		L*L̋ (px,py) Ƀ_ɃouSƂA
//		 Lx*Ly (cx,cy) ɍWϊĕzB
//		
//		L = SpaceAspect^(1/2) * theMaxY;
//		cx = SpaceAspect^(1/2) * theMaxX
//		cy = 1/SpaceAspect^(1/2) * theMaxY
//		
//	oȗ̐ς̊֌WF
//		theMaxX theMaxY theBVF == Pi R^2 n(R)
//	
//	theBNum > 0 ̂Ƃ̓ouwƂ݂Ȃ
//		n(R) = theBNum ƂAR vZ狁߂B
//	theBNum = 0 ̂Ƃ̓ouawƂ݂ȂA
//		R = theR Ƃ n vZ狁߂B
//
//	ۂɕzꂽTCgԂ.
//
int	distMap_WithSingleSizeBubble_transform(
		int	*theMap[], // zĕԂ}bv
		int		theMaxX,
		int		theMaxY,
		double	theBVF,	//	ou̕ϑ̐ϊ
		int	theBNum,//	oǔ
		double	theR,	//	ou̔a
		double	theAspect,	//	oũAXyNg
		double	theInclination	//	̃oǔX[degree]
)
{
	int	totalSiteNum;
	int	actualSiteNum;	//	ouŐ߂TCg
	int	occupiedSite;
	int			dx,dy;
//	double		tmpBVF;
	double		cx,cy;	//	eou̒SW
	double		x,y;	//	W
	double	xr,yr,xx,yy;//	]̍WAȉ~̌ʂW
	double	angle;	//	radian
	double	r,r2,major,minor;
	double	dist2;
	int		bnum;
	double		winW, winH, winX0,winY0,winX1,winY1;
	double		winWhalf, winHhalf;
	double		sqrtOfAspect, invsqrtOfAspect, cosAngle, sinAngle;
	//	ouuƂŃTCgɕω
	//	ׂEBhE
	//double		dRand;
	int		dotMode = 0;
	
	//	L*LԂ̍W
	//		L = SpaceAspect^(1/2) * theMaxY;
	int		maxL;	//	L*LԂ̂Pӂ̒.
	double	px, py;
	//	cx = SpaceAspect^(1/2) * px
	//	cy = 1/SpaceAspect^(1/2) * py
	//	L*LԂŔa͂ݏo
	double	pwinExtra;
	double	spaceAspect;	//	= Lx/Ly
	double	sqrtOfSpaceAspect;
	double	invsqrtOfSpaceAspect;
	//
	spaceAspect	= theMaxX / theMaxY;
	sqrtOfSpaceAspect = sqrt(spaceAspect);
	invsqrtOfSpaceAspect	= 1.0/sqrtOfSpaceAspect;
	maxL	= sqrtOfSpaceAspect * theMaxY;
	
//	printf("distMap_WithSingleSizeBubble_transform()\n");
//	printf("	maxL = %d\n", maxL);
	
	if( theBNum == 0 ){
		//ouaw
		r = theR;
		r2 = r*r;
		if( r > 0.0 ){
			bnum = (int) (theBVF * theMaxX * theMaxY / (THE_PI * r2));
		}
		else{
			dotMode = 1;
		}
	}
	else{//	ouw
		bnum = theBNum;
		r2 = (theBVF * theMaxX * theMaxY) / (THE_PI * bnum);
		r = sqrt(r2);
	}
	
	totalSiteNum = (int) (theBVF * theMaxX * theMaxY);
	actualSiteNum = 0;
	
	//	zoȕ
	ciDistributedBubbleNumber = 0;
	
	//==========================
	//	dot ̏ꍇ
	//==========================
	if( dotMode ){
		//	
		while( actualSiteNum < totalSiteNum ){
			//	L*LԂŃ_Ɉʒuw.
			px	= FUNC_RAND_DOUBLE() * maxL;
			py	= FUNC_RAND_DOUBLE() * maxL;
			
			//	Lx*LyԂɕϊ
			dx	= sqrtOfSpaceAspect * px;
			dy	= invsqrtOfSpaceAspect * py;
			
			if( 0<=dx && dx<theMaxX &&
					0<=dy && dy<theMaxY
					){
				if( theMap[dy][dx] == DATATYPE_VACANT ){
					theMap[dy][dx] = DATATYPE_OCCUPIED;
					actualSiteNum++;
				}
			}
		}//	while
	}//	if( dotMode )
	
	//==========================
	//	́Aȉ~̏ꍇ
	//==========================
	
	//	ȉ~̌`: 
	//	theAspect := major/minor
	//	Pi major minor == Pi r^2
	//		->	theAspect minor^2 = r^2
	//		->	minor = sqrt(r^2/theAspect)
	//	major = r * sqrt(theAspect)
	//	minor = r / sqrt(theAspect)
	sqrtOfAspect = sqrt(theAspect);
	invsqrtOfAspect	= 1.0/sqrtOfAspect;
	major = r * sqrtOfAspect;
	minor = r * invsqrtOfAspect;
	
	//	]pradianɕϊ
	angle = THE_PI * theInclination / 180.0;
	cosAngle	= cos(-angle);
	sinAngle	= sin(-angle);
	//	ڔ͈͂̃TCY
	winWhalf	= major+2.0;
	winHhalf	= major+2.0;
	winW = winWhalf*2.0;
	winH = winHhalf*2.0;
	
	//	L*LԂ̂͂ݏoeʁiρj
	pwinExtra	= sqrtOfSpaceAspect * ((winH>winW)? winH: winW);
	
	while( actualSiteNum < totalSiteNum ){
		
		//	Vȃou̍W
		//	0ȏ theMaxX * theMaxY -1 ȉ̗
		//intRand = my_int_rand(theMaxX * theMaxY -1);
		
		//	oũZ^[W
		//	SW͌n甼a͂ݏo.
		//	L*LԂŃ_Ɉʒuw.
		px	= FUNC_RAND_DOUBLE() * (maxL + pwinExtra);
		py	= FUNC_RAND_DOUBLE() * (maxL + pwinExtra);
		
		//	Lx*LyԂɕϊ
		cx	= sqrtOfSpaceAspect * px;	// 0 <= cx < theMaxX +winW
		cy	= invsqrtOfSpaceAspect * py;// 0 <= cy < theMaxY +winH
		
//		cx = FUNC_RAND_DOUBLE() * (theMaxX + winW);// 0 <= cx < theMaxX +winW
//		cy = FUNC_RAND_DOUBLE() * (theMaxY + winH);// 0 <= cy < theMaxY +winH
		cx -= winWhalf;	//	-winW/2 <= cx < theMaxX +winW/2
		cy -= winHhalf;	//	-winH/2 <= cy < theMaxY +winH/2
		
//		printf("(px,py)=(%4.2lf,%4.2lf) -> (cx,cy)=(%4.2lf,%4.2lf)\n", px,py,cx,cy);
		
		//	ڔ͈͂̐ݒ: 
		//	͈͕͂K^[Qbg̈ (0<=x<theMaxX, 0<=y<theMaxY) 
		//	܂悤.
		winX0 = cx - winWhalf;
		winX0 = (winX0 < 0.0)? 0:winX0;
		
		winX1 = cx + winWhalf;
		winX1 = ((double)theMaxX <= winX1)? (double)(theMaxX-1):winX1;
		
		winY0 = cy - winHhalf;
		winY0 = (winY0 < 0.0)? 0:winY0;
		
		winY1 = cy + winHhalf;
		winY1 = ((double)theMaxY <= winY1)? (double)(theMaxY-1):winY1;
		
		occupiedSite = 0;
		for(y=winY0; y<winY1+1.0; y+=0.5){
			for(x=winX0; x<winX1+1.0; x+=0.5){
				//	]̌ʁFɖ߂
				xr = cx+ (x-cx)*cosAngle - (y-cy)*sinAngle;
				yr = cy+ (x-cx)*sinAngle + (y-cy)*cosAngle;
				
				//	ȉ~̌ʁF~ɖ߂
				xx = cx + (xr -cx) * invsqrtOfAspect;
				yy = cy + (yr -cy) * sqrtOfAspect;
				
				//	xx, yy Aar̉~ɂlZbg
				dist2 = (xx-cx)*(xx-cx)+(yy-cy)*(yy-cy);
				if( dist2 <= r2 ){
					if( theMap[(int)y][(int)x] == DATATYPE_VACANT ){
						theMap[(int)y][(int)x] = DATATYPE_OCCUPIED;
						occupiedSite++;
					}
				}
			}//	for(x)
		}//	for(y)
		
		//	oũJEg.
		ciDistributedBubbleNumber += (occupiedSite > 0)? 1:0;
		
		//	TCg̃JEg.
		actualSiteNum += occupiedSite;
	}//	while()
	
  end:
	return	actualSiteNum;
}//	distMap_WithSingleSizeBubble_transform()





//
//	TEST:	L*LŊiq͗lɃ_zuALx*LyɍWϊ.
//
int	distMap_WithSingleSizeBubble_transformTEST(
		int	*theMap[], // zĕԂ}bv
		int		theMaxX,
		int		theMaxY,
		double	theBVF,	//	ou̕ϑ̐ϊ
		int	theBNum,//	oǔ
		double	theR,	//	ou̔a
		double	theAspect,	//	oũAXyNg
		double	theInclination	//	̃oǔX[degree]
)
{
	int	totalSiteNum;
	int	actualSiteNum;	//	ouŐ߂TCg
	int	occupiedSite;
	int			dx,dy;
//	double		tmpBVF;
	double		cx,cy;	//	eou̒SW
	double		x,y;	//	W
	double	xr,yr,xx,yy;//	]̍WAȉ~̌ʂW
	double	angle;	//	radian
	double	r,r2,major,minor;
	double	dist2;
	int		bnum;
	double		winW, winH, winX0,winY0,winX1,winY1;
	double		winWhalf, winHhalf;
	double		sqrtOfAspect, invsqrtOfAspect, cosAngle, sinAngle;
	//	ouuƂŃTCgɕω
	//	ׂEBhE
	//double		dRand;
	int		dotMode = 0;
	//  
	//  ziq͗lp̕ϐ
	double		barnum;	//	Ȃ̖{
	double		barinterval;	//	Ȃ̊Ԋu
	double		bar0x, bar0y;
	
	//	L*LԂ̍W
	//		L = SpaceAspect^(1/2) * theMaxY;
	int		maxL;	//	L*LԂ̂Pӂ̒.
	double	px, py;
	//	cx = SpaceAspect^(1/2) * px
	//	cy = 1/SpaceAspect^(1/2) * py
	//	L*LԂŔa͂ݏo
	double	pwinExtra;
	double	spaceAspect;	//	= Lx/Ly
	double	sqrtOfSpaceAspect;
	double	invsqrtOfSpaceAspect;
	//
	spaceAspect	= theMaxX / theMaxY;
	sqrtOfSpaceAspect = sqrt(spaceAspect);
	invsqrtOfSpaceAspect	= 1.0/sqrtOfSpaceAspect;
	maxL	= sqrtOfSpaceAspect * theMaxY;
	
//	printf("distMap_WithSingleSizeBubble_transform()\n");
//	printf("	maxL = %d\n", maxL);
	
	//  iq͗l
	barnum		= maxL * theBVF * 2;
	barinterval = maxL / barnum;
	bar0x	= my_int_rand(maxL -1);
	bar0y	= my_int_rand(maxL -1);
	
	if( theBNum == 0 ){
		//ouaw
		r = theR;
		r2 = r*r;
		if( r > 0.0 ){
			bnum = (int) (theBVF * theMaxX * theMaxY / (THE_PI * r2));
		}
		else{
			dotMode = 1;
		}
	}
	else{//	ouw
		bnum = theBNum;
		r2 = (theBVF * theMaxX * theMaxY) / (THE_PI * bnum);
		r = sqrt(r2);
	}
	
	totalSiteNum = (int) (theBVF * theMaxX * theMaxY);
	actualSiteNum = 0;
	
	//	zoȕ
	ciDistributedBubbleNumber = 0;
	
	//==========================
	//	dot ̏ꍇ
	//==========================
	if( dotMode ){
		//	
		while( actualSiteNum < totalSiteNum ){
			//	L*LԂŃ_Ɉʒuw.
//			px	= FUNC_RAND_DOUBLE() * maxL;
//			py	= FUNC_RAND_DOUBLE() * maxL;
			
			//	L*LԂŊiqɈʒuw.
			barinterval = maxL / (barnum);
			cx	= my_int_rand(barnum-1) + my_int_rand(barinterval/2)-barinterval/4;
			cy	= my_int_rand(barnum-1) + my_int_rand(barinterval/2)-barinterval/4;
			px  = bar0x + cx * (barinterval);
			py  = bar0y + cy * (barinterval);
			px  = (px < maxL)? px: px-maxL;
			py  = (py < maxL)? py: py-maxL;
			
			//	Lx*LyԂɕϊ
			dx	= sqrtOfSpaceAspect * px;
			dy	= invsqrtOfSpaceAspect * py;
			
			if( 0<=dx && dx<theMaxX &&
					0<=dy && dy<theMaxY
					){
				if( theMap[dy][dx] == DATATYPE_VACANT ){
					theMap[dy][dx] = DATATYPE_OCCUPIED;
					actualSiteNum++;
				}
			}
		}//	while
	}//	if( dotMode )
	
	//==========================
	//	́Aȉ~̏ꍇ
	//==========================
	
	//	ȉ~̌`: 
	//	theAspect := major/minor
	//	Pi major minor == Pi r^2
	//		->	theAspect minor^2 = r^2
	//		->	minor = sqrt(r^2/theAspect)
	//	major = r * sqrt(theAspect)
	//	minor = r / sqrt(theAspect)
	sqrtOfAspect = sqrt(theAspect);
	invsqrtOfAspect	= 1.0/sqrtOfAspect;
	major = r * sqrtOfAspect;
	minor = r * invsqrtOfAspect;
	
	//	]pradianɕϊ
	angle = THE_PI * theInclination / 180.0;
	cosAngle	= cos(-angle);
	sinAngle	= sin(-angle);
	//	ڔ͈͂̃TCY
	winWhalf	= major+2.0;
	winHhalf	= major+2.0;
	winW = winWhalf*2.0;
	winH = winHhalf*2.0;
	
	//	L*LԂ̂͂ݏoeʁiρj
	pwinExtra	= sqrtOfSpaceAspect * ((winH>winW)? winH: winW);
	
	//  iq͗l
	barinterval = 16;
	barnum = (maxL + pwinExtra) / barinterval;
	bar0x	= my_int_rand((maxL + pwinExtra) -1);
	bar0y	= my_int_rand((maxL + pwinExtra) -1);
	
	while( actualSiteNum < totalSiteNum ){
		
		//	Vȃou̍W
		//	0ȏ theMaxX * theMaxY -1 ȉ̗
		//intRand = my_int_rand(theMaxX * theMaxY -1);
		
		//	oũZ^[W
		//	SW͌n甼a͂ݏo.
		//	L*LԂŃ_Ɉʒuw.
		x	= my_int_rand(barnum-1);
		y	= my_int_rand(barnum-1);
		px  = bar0x + x * barinterval + my_int_rand(6)-3;
		py  = bar0y + y * barinterval + my_int_rand(6)-3;
		px  = (px < (maxL + pwinExtra))? px: px-(maxL + pwinExtra);
		py  = (py < (maxL + pwinExtra))? py: py-(maxL + pwinExtra);
		
		//	Lx*LyԂɕϊ
		cx	= sqrtOfSpaceAspect * px;	// 0 <= cx < theMaxX +winW
		cy	= invsqrtOfSpaceAspect * py;// 0 <= cy < theMaxY +winH
		
//		cx = FUNC_RAND_DOUBLE() * (theMaxX + winW);// 0 <= cx < theMaxX +winW
//		cy = FUNC_RAND_DOUBLE() * (theMaxY + winH);// 0 <= cy < theMaxY +winH
		cx -= winWhalf;	//	-winW/2 <= cx < theMaxX +winW/2
		cy -= winHhalf;	//	-winH/2 <= cy < theMaxY +winH/2
		
//		printf("(px,py)=(%4.2lf,%4.2lf) -> (cx,cy)=(%4.2lf,%4.2lf)\n", px,py,cx,cy);
		
		//	ڔ͈͂̐ݒ: 
		//	͈͕͂K^[Qbg̈ (0<=x<theMaxX, 0<=y<theMaxY) 
		//	܂悤.
		winX0 = cx - winWhalf;
		winX0 = (winX0 < 0.0)? 0:winX0;
		
		winX1 = cx + winWhalf;
		winX1 = ((double)theMaxX <= winX1)? (double)(theMaxX-1):winX1;
		
		winY0 = cy - winHhalf;
		winY0 = (winY0 < 0.0)? 0:winY0;
		
		winY1 = cy + winHhalf;
		winY1 = ((double)theMaxY <= winY1)? (double)(theMaxY-1):winY1;
		
		occupiedSite = 0;
		for(y=winY0; y<winY1+1.0; y+=0.5){
			for(x=winX0; x<winX1+1.0; x+=0.5){
				//	]̌ʁFɖ߂
				xr = cx+ (x-cx)*cosAngle - (y-cy)*sinAngle;
				yr = cy+ (x-cx)*sinAngle + (y-cy)*cosAngle;
				
				//	ȉ~̌ʁF~ɖ߂
				xx = cx + (xr -cx) * invsqrtOfAspect;
				yy = cy + (yr -cy) * sqrtOfAspect;
				
				//	xx, yy Aar̉~ɂlZbg
				dist2 = (xx-cx)*(xx-cx)+(yy-cy)*(yy-cy);
				if( dist2 <= r2 ){
					if( theMap[(int)y][(int)x] == DATATYPE_VACANT ){
						theMap[(int)y][(int)x] = DATATYPE_OCCUPIED;
						occupiedSite++;
					}
				}
			}//	for(x)
		}//	for(y)
		
		//	oũJEg.
		ciDistributedBubbleNumber += (occupiedSite > 0)? 1:0;
		
		//	TCg̃JEg.
		actualSiteNum += occupiedSite;
	}//	while()
	
  end:
	return	actualSiteNum;
}//	distMap_WithSingleSizeBubble_transformTEST()


int	get_distributedBubbleNumber()
{
	return	ciDistributedBubbleNumber;
}





//  10  eXgzu A
//			xɑ΂ĈԊuŁAyɈ̃C̐ϊɉĈ
int	distMap_WithSingleSizeBubble_intTEST10(
		int	*theMap[],
		int		theMaxX,
		int		theMaxY,
		double	theBVF,	//	ou̕ϑ̐ϊ
		int	theBNum,//	oǔ
		double	theR,	//	ou̔a
		double	theAspect,	//	oũAXyNg
		double	theInclination	//	̃oǔX[degree]
)
{
//	int	totalSiteNum;
	int	actualSiteNum;	//	ouŐ߂TCg
//	int	occupiedSite;
	int		x/*,y*/;	//	
	int		cx,cy;	//	
	int		barnum;	//	Ȃ̖{
	int		barinterval;	//	Ȃ̊Ԋu
	int		bar0;
	
	barnum	= theMaxX * theBVF;
	barinterval = theMaxX / barnum;
	bar0	= my_int_rand(theMaxX -1);
	
	actualSiteNum = 0;
	
	//	zoȕ
	ciDistributedBubbleNumber = 0;
	
	for(x=0; x<theMaxX; x+=barinterval){
		//	x  bar0 ͂
		
		cx = (bar0+x < theMaxX)? bar0+x: bar0+x-theMaxX;
		for(cy=0; cy<theMaxY; cy++){
			theMap[cy][cx] = DATATYPE_OCCUPIED;
			actualSiteNum += 1;
		}//	cy
	}//	x
	
	ciDistributedBubbleNumber = actualSiteNum;
	
  end:
	return	actualSiteNum;
}//	distMap_WithSingleSizeBubble_intTEST10()




//  11  eXgzu B
//			yɑ΂ĈԊuŁAxɈ̃C̐ϊɉĈ
int	distMap_WithSingleSizeBubble_intTEST11(
		int	*theMap[],
		int		theMaxX,
		int		theMaxY,
		double	theBVF,	//	ou̕ϑ̐ϊ
		int	theBNum,//	oǔ
		double	theR,	//	ou̔a
		double	theAspect,	//	oũAXyNg
		double	theInclination	//	̃oǔX[degree]
)
{
//	int	totalSiteNum;
	int	actualSiteNum;	//	ouŐ߂TCg
//	int	occupiedSite;
	int		/*x,*/y;	//	
	int		cx,cy;	//	
	int		barnum;	//	Ȃ̖{
	int		barinterval;	//	Ȃ̊Ԋu
	int		bar0;
	
	barnum	= theMaxY * theBVF;
	barinterval = theMaxY / barnum;
	bar0	= my_int_rand(theMaxY -1);
	
	actualSiteNum = 0;
	
	//	zoȕ
	ciDistributedBubbleNumber = 0;
	
	for(y=0; y<theMaxY; y+=barinterval){
		//	y  bar0 ͂
		
		cy = (bar0+y < theMaxY)? bar0+y: bar0+y-theMaxY;
		for(cx=0; cx<theMaxX; cx++){
			theMap[cy][cx] = DATATYPE_OCCUPIED;
			actualSiteNum += 1;
		}//	cx
	}//	y
	
	ciDistributedBubbleNumber = actualSiteNum;
	
  end:
	return	actualSiteNum;
}//	distMap_WithSingleSizeBubble_intTEST11()



//  12  eXgzu C
//			x,yɑ΂ĈԊůiq͗l̂Ȃ烉_ɔzu
int	distMap_WithSingleSizeBubble_intTEST12(
		int	*theMap[],
		int		theMaxX,
		int		theMaxY,
		double	theBVF,	//	ou̕ϑ̐ϊ
		int	theBNum,//	oǔ
		double	theR,	//	ou̔a
		double	theAspect,	//	oũAXyNg
		double	theInclination	//	̃oǔX[degree]
)
{
	int	totalSiteNum;
	int	actualSiteNum;	//	ouŐ߂TCg
	int	occupiedSite;
	int		cx,cy;	//	eou̒SW
//	double	tmpBVF;
	int		x,y;	//	W
	double	xr,yr,xx,yy;//	]̍WAȉ~̌ʂW
	double	angle;	//	radian
	double	r,r2,major,minor;
	double	dist2;
	int	bnum;
	int		winW, winH, winX0,winY0,winX1,winY1;
	int		winWhalf, winHhalf;
	double		sqrtOfAspect, invsqrtOfAspect, cosAngle, sinAngle;
	//	ouuƂŃTCgɕω
	//	ׂEBhE
//	int		intRand;
	int		dotMode = 0;
	//  
	//  ziq͗lp̕ϐ
	double		barnumx,barnumy;//	Ȃ̖{
	double		barinterval;	//	Ȃ̊Ԋu
	double		bar0x, bar0y;
	
	//  iq͗l
	if( theMaxX > theMaxY ){
		barnumx = theMaxX * theBVF * 2;
		barinterval = theMaxX / barnumx;
		barnumy = theMaxY / barinterval;
	}
	else{
		barnumy = theMaxY * theBVF * 2;
		barinterval = theMaxY / barnumy;
		barnumx = theMaxX / barinterval;
	}
	
	bar0x	= my_int_rand(theMaxX -1);
	bar0y	= my_int_rand(theMaxY -1);
	
	if( theBNum == 0 ){
		//ouaw
		r = theR;
		r2 = r*r;
		if( r > 0.0 ){
			bnum = (int) (theBVF * theMaxX * theMaxY / (THE_PI * r2));
		}
		else{
			dotMode = 1;
		}
	}
	else{//	ouw
		bnum = theBNum;
		r2 = (theBVF * theMaxX * theMaxY) / (THE_PI * bnum);
		r = sqrt(r2);
	}
	
	totalSiteNum = (int) (theBVF * theMaxX * theMaxY);
	actualSiteNum = 0;
	
	//	zoȕ
	ciDistributedBubbleNumber = 0;
	
	//==========================
	//	dot ̏ꍇ
	//==========================
	if( dotMode ){
		//	
		while( actualSiteNum < totalSiteNum ){
//			intRand = my_int_rand(theMaxX * theMaxY -1);
//			cx	= intRand % theMaxX;
//			cy	= intRand / theMaxX;

			//	iqɈʒuw.
			x	= my_int_rand(barnumx-1);
			y	= my_int_rand(barnumy-1);
			cx  = bar0x + x * (barinterval) + my_int_rand(barinterval/2)-barinterval/4;
			cy  = bar0y + y * (barinterval) + my_int_rand(barinterval/2)-barinterval/4;
			cx  = (cx < theMaxX)? cx: cx-theMaxX;
			cy  = (cy < theMaxY)? cy: cy-theMaxY;
			
			if( theMap[cy][cx] == DATATYPE_VACANT ){
				theMap[cy][cx] = DATATYPE_OCCUPIED;
				actualSiteNum++;
			}
		}//	while
	}//	if( dotMode )
	
	//==========================
	//	́Aȉ~̏ꍇ
	//==========================
	
	//	ȉ~̌`: 
	//	theAspect := major/minor
	//	Pi major minor == Pi r^2
	//		->	theAspect minor^2 = r^2
	//		->	minor = sqrt(r^2/theAspect)
	//	major = r * sqrt(theAspect)
	//	minor = r / sqrt(theAspect)
	sqrtOfAspect = sqrt(theAspect);
	invsqrtOfAspect	= 1.0/sqrtOfAspect;
	major = r * sqrtOfAspect;
	minor = r * invsqrtOfAspect;
	
	//	]pradianɕϊ
	angle = THE_PI * theInclination / 180.0;
	cosAngle	= cos(-angle);
	sinAngle	= sin(-angle);
	//	ڔ͈͂̃TCY
	winWhalf	= major+2;
	winHhalf	= major+2;
	winW = winWhalf*2;
	winH = winHhalf*2;
	
	//  iq͗l
	if( theMaxX > theMaxY ){
		barinterval = 16;	//(theMaxX + winW) / barnumx;
		barnumx = (theMaxX + winW) / barinterval;
		barnumy = (theMaxY + winH) / barinterval;
	}
	else{
		barinterval = 16;	//(theMaxX + winW) / barnumx;
		barnumx = (theMaxX + winW) / barinterval;
		barnumy = (theMaxY + winH) / barinterval;
	}
	
	bar0x	= my_int_rand((theMaxX + winW) -1);
	bar0y	= my_int_rand((theMaxY + winH) -1);
	
	while( actualSiteNum < totalSiteNum ){
		
		//	Vȃou̍W
		//	0ȏ theMaxX * theMaxY -1 ȉ̗
		//intRand = my_int_rand(theMaxX * theMaxY -1);
//		intRand = my_int_rand((theMaxX+winW) * (theMaxY+winH) -1);
		
		//	oũZ^[W
		//	SW͌n甼a͂ݏo.
		//	L*LԂŃ_Ɉʒuw.
		x	= my_int_rand(barnumx-1);
		y	= my_int_rand(barnumy-1);
		cx  = bar0x + x * barinterval + my_int_rand(6)-3;
		cy  = bar0y + y * barinterval + my_int_rand(6)-3;
		cx  = (cx < (theMaxX + winW))? cx: cx-(theMaxX + winW);
		cy  = (cy < (theMaxY + winW))? cy: cy-(theMaxY + winW);
		
		//	oũZ^[W
//		cx = intRand % (theMaxX+winW);
//		cy = intRand / (theMaxX+winW);
		cx -= winWhalf;	//	-winW/2 <= cx < theMaxX +winW/2
		cx -= winHhalf;	//	-winH/2 <= cy < theMaxY +winH/2
		
		//	ڔ͈͂̐ݒ
		winX0 = cx - winWhalf; winX0 = (winX0 < 0)? 0:winX0;
		winX1 = cx + winWhalf; winX1 = (theMaxX <= winX1)? theMaxX-1:winX1;
		winY0 = cy - winHhalf; winY0 = (winY0 < 0)? 0:winY0;
		winY1 = cy + winHhalf; winY1 = (theMaxY <= winY1)? theMaxY-1:winY1;
		
		occupiedSite = 0;
		for(y=winY0; y<=winY1; y++){
			for(x=winX0; x<=winX1; x++){
				//	]̌ʁFɖ߂
				xr = cx+ (double)(x-cx)*cosAngle - (double)(y-cy)*sinAngle;
				yr = cy+ (double)(x-cx)*sinAngle + (double)(y-cy)*cosAngle;
				
				//	ȉ~̌ʁF~ɖ߂
				xx = cx + (xr -(double)cx) * invsqrtOfAspect;
				yy = cy + (yr -(double)cy) * sqrtOfAspect;
				
				//	xx, yy Aar̉~ɂlZbg
				dist2 = (xx-(double)cx)*(xx-(double)cx)
						+(yy-(double)cy)*(yy-(double)cy);
				if( dist2 <= r2 ){
					if( theMap[y][x] == DATATYPE_VACANT ){
						theMap[y][x] = DATATYPE_OCCUPIED;
						occupiedSite++;
					}
				}
			}//	for(x)
		}//	for(y)
		
		//	oũJEg.
		ciDistributedBubbleNumber += (occupiedSite > 0)? 1:0;
		
		//	TCg̃JEg.
		actualSiteNum += occupiedSite;
	}//	while()
	
  end:
	return	actualSiteNum;
}//	distMap_WithSingleSizeBubble_intTEST12()





//	L*L Ԃł̃_zu
//		L*L̋ (px,py) Ƀ_ɃouSƂA
//		 Lx*Ly (cx,cy) ɍWϊĕzB
//		
//		L = SpaceAspect^(1/2) * theMaxY;
//		cx = SpaceAspect^(1/2) * theMaxX
//		cy = 1/SpaceAspect^(1/2) * theMaxY
//		
//	oȗ̐ς̊֌WF
//		theMaxX theMaxY theBVF == Pi R^2 n(R)
//	
//	theBNum > 0 ̂Ƃ̓ouwƂ݂Ȃ
//		n(R) = theBNum ƂAR vZ狁߂B
//	theBNum = 0 ̂Ƃ̓ouawƂ݂ȂA
//		R = theR Ƃ n vZ狁߂B
//  
//  ********************************************************
//  ouTCYz̎: mx֐ P(x)
//		ϒl m, W΍ s ̐Kz P(x) = ȗ
//		ϒl m ̎wz
//			P(x) = 1/m Exp[-x/m]
//		w a, ͈[b,c] ̃xLz, c<x ƂȂ x ͖.
//			P(x) = |(-a+1) (1/b)^(-a+1)| x^(-a)
//  ********************************************************
//  ۂ̔zȗO ezɏ] r 𔭐Ãoua r 
//  L^(BSD쐬)ȂAӂ
//		' = 1-Exp[-v n],
//				v:ouP̐L̐ =  r'^2 (2D),
//				n:oux N'/(Lx*Ly)
//  ŌςĂB
//  ' > 1.1  ܂ BSD 쐬ĂB
//  
//   r 傫Ƀ\[gA傫zuĂB
//  zu̍ۂ́Ar̃ouɑ΂āAłVKɋԂ𖄂߂邱Ƃ
//  łƂmFȂAN' ̃ouSĂzuB
//  N' ߂Ƃ̐L̐ϊӂ߂Bw肵lƂĂĂCɂȂB
//  
//  ********************************************************
//	ς̃ouTCY r' ́AouTCYz̕ϒl m Ƃ͈قȂB
//  ar̊mxz֐P(r) ƂA
//  ԂL鑍ou̐ς At ƂƁA
//		At = P(r)  r^2 N' ̐ϕ
//  ŁA
//		At = N'  r'^2
//  
//		r'^2 = P(r) r^2 N' ̐ϕ = @ P(r) r^2 dr.
//  
//  ͈ m<= r<= n ̈lz̏ꍇ
//		r'^2 = (1/3) (m^2 + m n + n^2)
//  
//  ϒl m, W΍ s ̃KEVȀꍇ
//		r'^2 = m^2 + s^2
//  
//  ϒl m ̎wz̏ꍇ
//		r'^2 = 2 m^2
//  
//  w a, ͈ m<= r<= n ̃xLz̏ꍇ
//             (a-1) (-m^a n^3 + m^3 n^a)
//		r'^2 = --------------------------
//             (a-3) (-m^a n + m n^a)
//  ********************************************************
//  
//	ۂɕzꂽTCgԂ.
//
#define MAXBNUM 1000000
static double   cDist_MeanBubbleSize = 0.0;
static double   cDist_StdDevBubbleSize = 0.0;
//  *** BSD ***
static double   cBSD[MAXBNUM];   //  ouaL^Ăz
static int		cBSDnum;		//  zɋL^ꂽvf
static int		cBSDstartID;	//  zuJnvfԍ(!= bnum)
//  p͈͂ \[eBÕASYAcBSD[1] ~ cBSD[bnum]B
//  q[v\[g heap_sort() ɂāAzŏijɕבւB
//  cBSD[0] ͗pȂB
//  vf: bnum
#define EXTRA_BSD_CONST 0.5
int	distMap_WithBubbleSizeDist_transform(
		int	*theMap[], // zĕԂ}bv
		int		theMaxX,
		int		theMaxY,
		double	theBVF,	//	ou̕ϑ̐ϊ
//		int	theBNum,//	oǔ
		double	theR,	//	ou̕ϔa
		double	theAspect,	//	oũAXyNg
		double	theInclination,	//	̃oǔX[degree]
		//  BSD֌W
		int		theBSDType, //  1: lz, 2: Kz, 3:w, 4:xL
		double  theBSDOpt[] //  BSDType ɂĈقȂ.
		//  l: theBSDOpt[0] => []
		//  K: theBSDOpt[0] => W΍
		//  w: theBSDOpt[0] => []
		//  xL: theBSDOpt[0] => w
		//  
		//  : theBSDOpt[1] => TCỶ, theBSDOpt[2] => TCY̏
)
{
	int	totalSiteNum;
	int	actualSiteNum;	//	ouŐ߂TCg
	int	occupiedSite;
//	int			dx,dy;
	double		tmpBVF, sumEachArea, sysAreaInv;
	double		cx,cy;	//	eou̒SW
	double		x,y;	//	W
	double	xr,yr,xx,yy;//	]̍WAȉ~̌ʂW
	double	angle;	//	radian
	double	r,r2,major,minor/*, rAve2*/;
	double	dist2;
	int	n, bnum/*, bnumOrg*/;   // Sou
	double		winW, winH, winX0,winY0,winX1,winY1;
	double		winWhalf, winHhalf;
	double		sqrtOfAspect, invsqrtOfAspect, cosAngle, sinAngle;
	//	ouuƂŃTCgɕω
	//	ׂEBhE
	//double		dRand;
	
	//  *** BSD ***
	double  a,b,c;
	double	bsdCoef;
	
	//	L*LԂ̍W
	//		L = SpaceAspect^(1/2) * theMaxY;
	int		maxL;	//	L*LԂ̂Pӂ̒.
	double	px, py;
	//	cx = SpaceAspect^(1/2) * px
	//	cy = 1/SpaceAspect^(1/2) * py
	//	L*LԂŔa͂ݏo
	double	pwinExtra;
	double	spaceAspect;	//	= Lx/Ly
	double	sqrtOfSpaceAspect;
	double	invsqrtOfSpaceAspect;
	//
	spaceAspect	= theMaxX / theMaxY;
	sqrtOfSpaceAspect = sqrt(spaceAspect);
	invsqrtOfSpaceAspect	= 1.0/sqrtOfSpaceAspect;
	maxL	= sqrtOfSpaceAspect * theMaxY;
	
//	printf("theMaxX = %d, theMaxY = %d\n", theMaxX, theMaxY);
//	printf("distMap_WithSingleSizeBubble_transform()\n");
//	printf("	maxL = %d\n", maxL);
	
	//  BSD IvVɂ
	a = theBSDOpt[0];
	b = theBSDOpt[1];   //  TCỶ
	c = theBSDOpt[2];   //  TCY̏
	
	/*******
	******/
	
	cBSD[0] = 0;
	//  ouTCYz̍쐬
	//  BSD 쐬Ȃӂ𐄒
	n = bnum = 0;
	tmpBVF = sumEachArea = 0.0;
	sysAreaInv = 1.0/(theMaxX * theMaxY);
	if( theBSDType == BSDTYPE_GAUSSIAN ){
		bsdCoef	= 1.1125 - 0.125 * theBVF;	//	W theBVF ɂĂ.
	}
	else{
		bsdCoef	= 1.225 - 0.25 * theBVF;	//	W theBVF ɂĂ.
	}
	while( tmpBVF < bsdCoef * theBVF ){
		if( theBSDType == BSDTYPE_UNIF_RANDOM ){
			//  lz:  b,  c
			cBSD[n] = b + (c - b) * rand_unifm_d();
		}
		else if( theBSDType == BSDTYPE_GAUSSIAN ){
			//	Kz: ϒl theR, W΍ a
			cBSD[n] = rand_norm_d(theR, a);
			while( cBSD[n] < b || c < cBSD[n] ){
				cBSD[n] = rand_norm_d(theR, a);
			}
		}
		else if( theBSDType == BSDTYPE_EXPONENTIAL ){
			//   wz: ϒl theR
			cBSD[n] = rand_exp_d(theR);
			while( cBSD[n] < b || c < cBSD[n] ){
				cBSD[n] = rand_exp_d(theR);
			}
		}
		else if( theBSDType == BSDTYPE_POWERLAW ){
			//   xLz: w a,  b,  c
			cBSD[n] = rand_power_d(a, b, c);
		}
		else{// xLz: w a,  b,  c
			cBSD[n] = rand_power_d(a, b, c);
		}
		
		//  
		r2 = cBSD[n];
		r2 *= r2;
		sumEachArea += THE_PI * r2;
		tmpBVF = 1.0-exp(-sumEachArea*sysAreaInv);
		
		n++;
	}// while
	//  
	//  cBSD[]̗vf
	bnum = (cBSDnum = n);
	cBSDstartID = bnum;
	printf("tmpBVF %lf ", tmpBVF);
	
	//
	//  TCYz̃\[eBO
	//		cBSD[1] ~ cBSD[bnum] ̊ԂŏɁijבւB
	heap_sort(bnum, cBSD);
	
	
	totalSiteNum = (int) (theBVF * theMaxX * theMaxY);
	actualSiteNum = 0;
	
	//	zoȕ
	ciDistributedBubbleNumber = 0;
	//  
	cDist_MeanBubbleSize	= 0.0;
	cDist_StdDevBubbleSize  = 0.0;
	
	//==========================
	//	ȉ~̏ꍇ
	//==========================
	
	//	]pradianɕϊ
	angle = THE_PI * theInclination / 180.0;
	cosAngle	= cos(-angle);
	sinAngle	= sin(-angle);
	
	//  zu
	n = cBSDstartID;	// bnum;
	while( n > 0 && actualSiteNum < totalSiteNum ){
		//  bnum ́ATCY cBSD[1]~cBSD[bnum] ̃ouzuΏIB
		//  ̑OɕzTCgK𒴂Iîׂ͖j
		
		//  VɔzuouTCY
		r = cBSD[n];
		r2 = r * r;
		
		//	ȉ~̌`: 
		//	theAspect := major/minor
		//	Pi major minor == Pi r^2
		//		->	theAspect minor^2 = r^2
		//		->	minor = sqrt(r^2/theAspect)
		//	major = r * sqrt(theAspect)
		//	minor = r / sqrt(theAspect)
		sqrtOfAspect = sqrt(theAspect);
		invsqrtOfAspect	= 1.0/sqrtOfAspect;
		major = r * sqrtOfAspect;
		minor = r * invsqrtOfAspect;
		
		//	ڔ͈͂̃TCY
		winWhalf	= major+2.0;
		winHhalf	= major+2.0;
		winW = winWhalf*2.0;
		winH = winHhalf*2.0;
		
		//	L*LԂ̂͂ݏoeʁiρj
		pwinExtra	= sqrtOfSpaceAspect * ((winH>winW)? winH: winW);
		
		occupiedSite = 0;
		while( occupiedSite == 0 ){
			//  m r ̃ouƂłԂVKɐL܂Ŕzu낢뎎B
			
			//	Vȃou̍W
			//	0ȏ theMaxX * theMaxY -1 ȉ̗
			//intRand = my_int_rand(theMaxX * theMaxY -1);
			
			//	oũZ^[W
			//	SW͌n甼a͂ݏo.
			//	L*LԂŃ_Ɉʒuw.
			px	= FUNC_RAND_DOUBLE() * (maxL + pwinExtra);
			py	= FUNC_RAND_DOUBLE() * (maxL + pwinExtra);
			
			//	Lx*LyԂɕϊ
			cx	= sqrtOfSpaceAspect * px;	// 0 <= cx < theMaxX +winW
			cy	= invsqrtOfSpaceAspect * py;// 0 <= cy < theMaxY +winH
			
	//		cx = FUNC_RAND_DOUBLE() * (theMaxX + winW);// 0 <= cx < theMaxX +winW
	//		cy = FUNC_RAND_DOUBLE() * (theMaxY + winH);// 0 <= cy < theMaxY +winH
			cx -= winWhalf;	//	-winW/2 <= cx < theMaxX +winW/2
			cy -= winHhalf;	//	-winH/2 <= cy < theMaxY +winH/2
			
	//		printf("(px,py)=(%4.2lf,%4.2lf) -> (cx,cy)=(%4.2lf,%4.2lf)\n", px,py,cx,cy);
			
			//	ڔ͈͂̐ݒ: 
			//	͈͕͂K^[Qbg̈ (0<=x<theMaxX, 0<=y<theMaxY) 
			//	܂悤.
			winX0 = cx - winWhalf;
			winX0 = (winX0 < 0.0)? 0:winX0;
			
			winX1 = cx + winWhalf;
			winX1 = ((double)theMaxX <= winX1)? (double)(theMaxX-1):winX1;
			
			winY0 = cy - winHhalf;
			winY0 = (winY0 < 0.0)? 0:winY0;
			
			winY1 = cy + winHhalf;
			winY1 = ((double)theMaxY <= winY1)? (double)(theMaxY-1):winY1;
			
			//occupiedSite = 0;
			for(y=winY0; y<winY1+1.0; y+=0.5){
				for(x=winX0; x<winX1+1.0; x+=0.5){
					//	]̌ʁFɖ߂
					xr = cx+ (x-cx)*cosAngle - (y-cy)*sinAngle;
					yr = cy+ (x-cx)*sinAngle + (y-cy)*cosAngle;
					
					//	ȉ~̌ʁF~ɖ߂
					xx = cx + (xr -cx) * invsqrtOfAspect;
					yy = cy + (yr -cy) * sqrtOfAspect;
					
					//	xx, yy Aar̉~ɂlZbg
					dist2 = (xx-cx)*(xx-cx)+(yy-cy)*(yy-cy);
					if( dist2 <= r2 ){
						if( theMap[(int)y][(int)x] == DATATYPE_VACANT ){
							theMap[(int)y][(int)x] = DATATYPE_OCCUPIED;
							occupiedSite++;
						}
					}
				}//	for(x)
			}//	for(y)
		}// while( occupiedSite == 0 )
		
		cDist_MeanBubbleSize	+= r;
		cDist_StdDevBubbleSize  += r * r;
		
		//	oũJEg.
		ciDistributedBubbleNumber += (occupiedSite > 0)? 1:0;
		
		//	TCg̃JEg.
		actualSiteNum += occupiedSite;
		
		//  JEg̍XV
		n--;
	}//	while()
	
	//  
	//  ϒlƕW΍̌vZ
	//		ʊ֐Œm邱ƂłB
	cDist_MeanBubbleSize	/= ciDistributedBubbleNumber;
	cDist_StdDevBubbleSize  = sqrt(fabs(ciDistributedBubbleNumber
			/ (ciDistributedBubbleNumber - 1.0) 
			* (cDist_StdDevBubbleSize / ciDistributedBubbleNumber - cDist_MeanBubbleSize * cDist_MeanBubbleSize)
		));
	
  end:
	return	actualSiteNum;
}//	distMap_WithBubbleSizeDist_transform()


double  get_Dist_MeanBubbleSize(){	return  cDist_MeanBubbleSize;}
double  get_Dist_StdDevBubbleSize(){	return  cDist_StdDevBubbleSize;}
int		get_BSDnum(){	return  cBSDnum;}
int		get_BSDstartID(){	return  cBSDstartID;}

double	get_BSD_at(int  n)
{
	double  d = -1.0;
	if( 0<n && n<=cBSDnum )
		d = cBSD[n];
	return  d;
}

