/*  -*- c++ -*-
  $Id: geometry.h 1511 2005-06-24 00:33:43Z yuk $
  $Date: 2005-06-24 09:33:43 +0900 (Fri, 24 Jun 2005) $
  $Rev: 1511 $
  $Author: yuk $
  */

#ifndef GEOMETRY_H_
#define GEOMETRY_H_

#include <iostream>
#include "utils.h"

class Geometry {
 private:
   const double origx;
   const double origy;
   const double origz;
   
   const double lenx;
   const double leny;
   const double lenz;
   
 public:
   Geometry(double lx,double ly,double lz,std::ostream& output = std::cerr)
      : origx(0),origy(0),origz(0),lenx(lx),leny(ly),lenz(lz)
      {

   };

   Geometry(double lx0,double ly0,double lz0,
	    double lx,double ly,double lz,std::ostream& output = std::cerr)
      : origx(lx0),origy(ly0),origz(lz0),lenx(lx),leny(ly),lenz(lz)
      {

   };
   
   double getOX(void) const {
      return origx;
   }
   double getOY(void) const{
      return origy;
   }
   double getOZ(void) const{
      return origz;
   }

   double getX(void) const {
      return lenx;
   }
   double getY(void) const{
      return leny;
   }
   double getZ(void) const{
      return lenz;
   }

};

#endif // GEOMETRY_H_
