/*
  -*- c++ -*-
  $Id: mtrand.h 1511 2005-06-24 00:33:43Z yuk $
  $Date: 2005-06-24 09:33:43 +0900 (Fri, 24 Jun 2005) $
  $Rev: 1511 $
  $Author: yuk $
 
*/


#ifndef MTRAND_H_
#define MTRAND_H_

class mtrand
{
  private:
   static const int N=624;
   static const int M=397;
   //  constant vector a 
   static const unsigned long MATRIX_A = 0x9908b0dfUL;  
   // most significant w-r bits 
   static const unsigned long UMASK= 0x80000000UL; 
   // least significant r bits 
   static const unsigned long LMASK= 0x7fffffffUL; 
   unsigned long mixbits(unsigned long u, unsigned long v){
      return (u & UMASK | v & LMASK);
   };
   unsigned long twist(unsigned long u, unsigned long v){
      return ((mixbits(u,v) >> 1)^ ((v)&1UL ? MATRIX_A : 0UL));
   };
   
   unsigned long state[N];
   int left ;
   int initf;
   
   unsigned long *next;

   unsigned long initialseed;
   
   void next_state(void);   
  public:
   mtrand(void);
   mtrand(unsigned long);
   ~mtrand(void);
   unsigned long genrand_int32(void);
   double genrand_real01(void);
   double genrand_real01b(void);
   double genrand_nd(void);
   double genrand_nd(double);
   unsigned long getInitialSeed(void){
      return initialseed;
   }
};

#endif // MTRAND_H_
