/*
 *  my_mpi.h
 *  percoCheck_com
 *
 *  Created by V on Sat Nov 06 2004.
 *  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
 *
 */
#ifndef MY_MPI
#define MY_MPI

#include	"compileOptions.h"

//============================================================
//	Set a machine type "MACHINE_*" in compileOptions.h
//============================================================
#if		defined( MACHINE_64bit_MPI )
	#define PARALLEL
#elif	defined( MACHINE_32bit_MPI )
	#define PARALLEL
#else
#endif


//============================================================
//	Don't modify below.
//============================================================
#ifdef  PARALLEL
	#include	<mpi.h>
#endif

//  Select one of plans for "mpi_localBnumTargetDensity"
#define MY_PLAN_A
//#define MY_PLAN_B
//#define MY_PLAN_C


/*
 MPI Datatype		C Datatype(eic) f[^
 -------------------------------------
 MPI_CHAR			char			1
 MPI_SHORT			short			2
 MPI_INT			int				4
 MPI_LONG			long			8
 MPI_UNSIGNED_CHAR 	unsigned char 	1
 MPI_UNSIGNED_SHORT unsinged short 	2
 MPI_UNSIGNED		unsinged int 	4
 MPI_UNSIGNED_LONG 	unsinged long 	8
 MPI_FLOAT			float			4
 MPI_DOUBLE			double			8
 MPI_LONG_DOUBLE 	long double 	16
 */


//  MPĨ^O
#define MYMPI_TAG_SYNC		100 //  ̃N rank0 

#define MYMPI_TAG_BNUM		110
#define MYMPI_TAG_SITENUM   111

#define MYMPI_TAG_BUBBLE_R  120
#define MYMPI_TAG_BUBBLE_CX 121
#define MYMPI_TAG_BUBBLE_CY 122
#define MYMPI_TAG_BUBBLE_CZ 123

#define MYMPI_TAG_BOXBIDa	130
#define MYMPI_TAG_BOXBNUMa	131
#define MYMPI_TAG_BOXNUMZ1	132
#define MYMPI_TAG_BOXBIDb	133
#define MYMPI_TAG_BOXBNUMb	134

#define MYMPI_TAG_BOUNDX_BIDNUM	140
#define MYMPI_TAG_BOUNDY_BIDNUM	141
#define MYMPI_TAG_BOUNDZ_BIDNUM	142

#define MYMPI_TAG_BOUNDX0_BID	150
#define MYMPI_TAG_BOUNDY0_BID	151
#define MYMPI_TAG_BOUNDZ0_BID	152

#define MYMPI_TAG_BOUNDX1_BID	160
#define MYMPI_TAG_BOUNDY1_BID	161
#define MYMPI_TAG_BOUNDZ1_BID	162

#define MYMPI_TAG_CLUSTIDLIST	170
#define MYMPI_TAG_CLUSTNUM		171

#define MYMPI_TAG_CLUSTSIZELIST	180

#define MYMPI_TAG_FINAL_BVF		190

#endif

