/*  -*- c++ -*-
    $Id: observable.hpp 1512 2005-06-24 00:57:06Z yuk $
    $Date: 2005-06-24 09:57:06 +0900 (Fri, 24 Jun 2005) $
    $Rev: 1512 $
    $Author: yuk $
  
    
*/


#ifndef OBSERVABLE_HPP_
#define OBSERVABLE_HPP_

#include <iostream>
#include "particles.h"
#include "dist.h"
#include "output.h"
#include "mesh.h"

namespace Observable 
{  
  template <class Model, class Boundary>
  void Energy(Particles& prtcls, 
              Model& pmodel, 
              PairTable& ptable,
              Boundary& bdry,
              std::ostream& output,
              double& kene, double& pene)
  {
    kene = prtcls.getKinEnergy();
    pene = prtcls.getPotEnergy<Model>(pmodel,ptable);
    
    output << kene << ' ' << pene << ' ' 
           << kene + pene  << ' ' ;
  }

}


#endif // OBSERVABLE_HPP_
