/*  -*- c++ -*-
  $Id: output.cpp 1234 2005-04-21 09:52:52Z yuk $
  $Date: 2005-04-21 18:52:52 +0900 (Thu, 21 Apr 2005) $
  $Rev: 1234 $
  $Author: yuk $
  
*/

#include <iostream>
#include <ctime>
#include <iomanip>
#include <string>

#include "output.h"
//----------------------------------------------------
OutPutFiles::OutPutFiles(int argc, char* argv[])
{
   // default headerを決める。
   if(argc == 1){
      header =  "LJbench";
   } else {
      header = argv[1];
   }
   
   std::string outstr = header + ".dat";
   std::string errstr = header + ".err";
   std::string logstr = header + ".log";
   out = new std::ofstream (outstr.c_str(),std::ios_base::app);
   log = new std::ofstream (logstr.c_str(),std::ios_base::app);
   err = new std::ofstream (errstr.c_str(),std::ios_base::app);
   
   
   *out << std::setprecision(15);
   *log << std::setprecision(15); 
   *err << std::setprecision(15);

   // today and time
   time_t a = time(0);
   char* p = asctime(localtime(&a));
   
   *out << "#-------------- " << p ;
   *out << "# binary name: " << argv[0] << '\n';
   
   *err << "--------------- " << p;
   *err << "binary name: " << argv[0] << '\n';
   
   *log << "--------------- " << p;
   *log << "binary name: " << argv[0] << '\n';
   
   *log << "Lennard Jones Benchmark " << '\n';
}
//-----------------------------------------------------
OutPutFiles::~OutPutFiles(void)
{
   
   time_t a = time(0);
   char* p = asctime(localtime(&a));

   *out << "#-------------- " << p<< std::endl;
   *err << "--------------- " << p<< std::endl;
   *log << "--------------- " << p<< std::endl;
   
   
   
   delete out;
   delete log;
   delete err;
   
}

//----------------------------------------------------
void OutPutFiles::flush(void)
{
   out->flush();
   log->flush();
   err->flush();
}
//----------------------------------------------------
