/*  -*- c++ -*-
  $Id: system.hpp 1512 2005-06-24 00:57:06Z yuk $
  $Date: 2005-06-24 09:57:06 +0900 (Fri, 24 Jun 2005) $
  $Rev: 1512 $
  $Author: yuk $
  
*/

#ifndef SYSTEM_HPP_ 
#define SYSTEM_HPP_ 

#include <iostream>
#include "utils.h"

class System 
{
 private:

 public:
   System(double ttemp, std::ostream& output = std::cerr,
          double tdt = 1e-3,int dti=1000):
      dt(tdt),temp(ttemp),dtinv(dti){
/*      info<double>("System","Temperature",temp,output);
        info<double>("System","Tinystep",dt,output); */
      globalstarttime = 0;
   }
   
   const double dt;
   const double temp;
   const int dtinv;
   
   unsigned long globalstarttime;
   
   double getTemperature(void) const{
      return temp;
   }
  //-------------------------------------
  void dumpParameter(std::ostream& output){
    output.write((char*) &globalstarttime,sizeof(unsigned long));
  }
  void setParameter(std::istream& input){
    input.read((char*)&globalstarttime,sizeof(unsigned long));
  }
   
};


#endif // SYSTEM_HPP_
   
   
