/*  -*- c++ -*-
  $Id: utils.h 1511 2005-06-24 00:33:43Z yuk $
  $Date: 2005-06-24 09:33:43 +0900 (Fri, 24 Jun 2005) $
  $Rev: 1511 $
  $Author: yuk $
  
*/

// utility functions

#ifndef UTILS_H_
#define UTILS_H_

#include <iostream>

template <class T>
void error(char* cname, char* outstr, T param, std::ostream& output) 
{
   output <<  cname << ": error:" << outstr 
 	  << ' ' << param<< std::endl;
}

template <class T>
void info(char* cname,char* outstr, T param, std::ostream& output) {
   output << "# "<< cname << ": info:"<< outstr 
	  << ' ' << param << std::endl;
}

template <class T1,class T2>
void info(char* cname, 
          char* outstr1,T1 param1, 
          char* outstr2,T2 param2,std::ostream& output) {
   output << "# "<< cname << ": info:"<< outstr1 
	  << ' ' << param1 
          << ' ' << outstr2 << ' ' << param2 << std::endl;
}


void error(char* cname, char* outstr,std::ostream& output);

void info(char* cname,char* outstr,std::ostream& output);

void pack(int num,int offset,double qx[] ,double qy[],double qz[],
	  double e0[],
	  double e1[],double e2[],double e3[],
	  double x1,double x2,double y1,
	  double y2,double z1,double z2,std::ostream& output);

unsigned long mkseeds(unsigned long seed,int myid,std::ostream&);

#endif // UTILS_H_
